<?php
/*
 * Copyright (c) 2025 AltumCode (https://altumcode.com/)
 *
 * This software is licensed exclusively by AltumCode and is sold only via https://altumcode.com/.
 * Unauthorized distribution, modification, or use of this software without a valid license is not permitted and may be subject to applicable legal actions.
 *
 * 🌍 View all other existing AltumCode projects via https://altumcode.com/
 * 📧 Get in touch for support or general queries via https://altumcode.com/contact
 * 📤 Download the latest version via https://altumcode.com/downloads
 *
 * 🐦 X/Twitter: https://x.com/AltumCode
 * 📘 Facebook: https://facebook.com/altumcode
 * 📸 Instagram: https://instagram.com/altumcode
 */

namespace Altum\Models;

defined('ALTUMCODE') || die();

class Category extends Model {

    public function get_category_by_store_id_and_url($store_id, $url) {

        /* Get the category */
        $category = null;

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('s_category?store_id=' . $store_id . '&url=' . md5($url));

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $category = database()->query("SELECT * FROM `categories` WHERE `store_id` = {$store_id} AND `url` = '{$url}'")->fetch_object() ?? null;

            cache()->save(
                $cache_instance->set($category)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $category = $cache_instance->get();

        }

        return $category;

    }

    public function get_categories_by_store_id_and_menu_id($store_id, $menu_id) {

        /* Get the store posts */
        $categories = [];

        /* Try to check if the store posts exists via the cache */
        $cache_instance = cache()->getItem('r_categories?store_id=' . $store_id . '&menu_id=' . $menu_id);

        /* Set cache if not existing */
        if(is_null($cache_instance->get())) {

            /* Get data from the database */
            $categories_result = database()->query("
                SELECT 
                    *
                FROM 
                    `categories` 
                WHERE 
                    `store_id` = {$store_id}
                    AND `menu_id` = {$menu_id} 
                    AND `is_enabled` = 1
                ORDER BY `order`
            ");
            while($row = $categories_result->fetch_object()) $categories[] = $row;

            cache()->save(
                $cache_instance->set($categories)->expiresAfter(CACHE_DEFAULT_SECONDS)->addTag('store_id=' . $store_id)
            );

        } else {

            /* Get cache */
            $categories = $cache_instance->get();

        }

        return $categories;

    }

}
